// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from smacc2_msgs:msg/SmaccTransition.idl
// generated code does not contain a copyright notice
#include "smacc2_msgs/msg/detail/smacc_transition__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `transition_name`
// Member `transition_type`
// Member `destiny_state_name`
// Member `source_state_name`
#include "rosidl_runtime_c/string_functions.h"
// Member `event`
#include "smacc2_msgs/msg/detail/smacc_event__functions.h"

bool
smacc2_msgs__msg__SmaccTransition__init(smacc2_msgs__msg__SmaccTransition * msg)
{
  if (!msg) {
    return false;
  }
  // index
  // transition_name
  if (!rosidl_runtime_c__String__init(&msg->transition_name)) {
    smacc2_msgs__msg__SmaccTransition__fini(msg);
    return false;
  }
  // transition_type
  if (!rosidl_runtime_c__String__init(&msg->transition_type)) {
    smacc2_msgs__msg__SmaccTransition__fini(msg);
    return false;
  }
  // destiny_state_name
  if (!rosidl_runtime_c__String__init(&msg->destiny_state_name)) {
    smacc2_msgs__msg__SmaccTransition__fini(msg);
    return false;
  }
  // source_state_name
  if (!rosidl_runtime_c__String__init(&msg->source_state_name)) {
    smacc2_msgs__msg__SmaccTransition__fini(msg);
    return false;
  }
  // history_node
  // event
  if (!smacc2_msgs__msg__SmaccEvent__init(&msg->event)) {
    smacc2_msgs__msg__SmaccTransition__fini(msg);
    return false;
  }
  return true;
}

void
smacc2_msgs__msg__SmaccTransition__fini(smacc2_msgs__msg__SmaccTransition * msg)
{
  if (!msg) {
    return;
  }
  // index
  // transition_name
  rosidl_runtime_c__String__fini(&msg->transition_name);
  // transition_type
  rosidl_runtime_c__String__fini(&msg->transition_type);
  // destiny_state_name
  rosidl_runtime_c__String__fini(&msg->destiny_state_name);
  // source_state_name
  rosidl_runtime_c__String__fini(&msg->source_state_name);
  // history_node
  // event
  smacc2_msgs__msg__SmaccEvent__fini(&msg->event);
}

bool
smacc2_msgs__msg__SmaccTransition__are_equal(const smacc2_msgs__msg__SmaccTransition * lhs, const smacc2_msgs__msg__SmaccTransition * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // index
  if (lhs->index != rhs->index) {
    return false;
  }
  // transition_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->transition_name), &(rhs->transition_name)))
  {
    return false;
  }
  // transition_type
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->transition_type), &(rhs->transition_type)))
  {
    return false;
  }
  // destiny_state_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->destiny_state_name), &(rhs->destiny_state_name)))
  {
    return false;
  }
  // source_state_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->source_state_name), &(rhs->source_state_name)))
  {
    return false;
  }
  // history_node
  if (lhs->history_node != rhs->history_node) {
    return false;
  }
  // event
  if (!smacc2_msgs__msg__SmaccEvent__are_equal(
      &(lhs->event), &(rhs->event)))
  {
    return false;
  }
  return true;
}

bool
smacc2_msgs__msg__SmaccTransition__copy(
  const smacc2_msgs__msg__SmaccTransition * input,
  smacc2_msgs__msg__SmaccTransition * output)
{
  if (!input || !output) {
    return false;
  }
  // index
  output->index = input->index;
  // transition_name
  if (!rosidl_runtime_c__String__copy(
      &(input->transition_name), &(output->transition_name)))
  {
    return false;
  }
  // transition_type
  if (!rosidl_runtime_c__String__copy(
      &(input->transition_type), &(output->transition_type)))
  {
    return false;
  }
  // destiny_state_name
  if (!rosidl_runtime_c__String__copy(
      &(input->destiny_state_name), &(output->destiny_state_name)))
  {
    return false;
  }
  // source_state_name
  if (!rosidl_runtime_c__String__copy(
      &(input->source_state_name), &(output->source_state_name)))
  {
    return false;
  }
  // history_node
  output->history_node = input->history_node;
  // event
  if (!smacc2_msgs__msg__SmaccEvent__copy(
      &(input->event), &(output->event)))
  {
    return false;
  }
  return true;
}

smacc2_msgs__msg__SmaccTransition *
smacc2_msgs__msg__SmaccTransition__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccTransition * msg = (smacc2_msgs__msg__SmaccTransition *)allocator.allocate(sizeof(smacc2_msgs__msg__SmaccTransition), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(smacc2_msgs__msg__SmaccTransition));
  bool success = smacc2_msgs__msg__SmaccTransition__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
smacc2_msgs__msg__SmaccTransition__destroy(smacc2_msgs__msg__SmaccTransition * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    smacc2_msgs__msg__SmaccTransition__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
smacc2_msgs__msg__SmaccTransition__Sequence__init(smacc2_msgs__msg__SmaccTransition__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccTransition * data = NULL;

  if (size) {
    data = (smacc2_msgs__msg__SmaccTransition *)allocator.zero_allocate(size, sizeof(smacc2_msgs__msg__SmaccTransition), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = smacc2_msgs__msg__SmaccTransition__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        smacc2_msgs__msg__SmaccTransition__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
smacc2_msgs__msg__SmaccTransition__Sequence__fini(smacc2_msgs__msg__SmaccTransition__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      smacc2_msgs__msg__SmaccTransition__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

smacc2_msgs__msg__SmaccTransition__Sequence *
smacc2_msgs__msg__SmaccTransition__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccTransition__Sequence * array = (smacc2_msgs__msg__SmaccTransition__Sequence *)allocator.allocate(sizeof(smacc2_msgs__msg__SmaccTransition__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = smacc2_msgs__msg__SmaccTransition__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
smacc2_msgs__msg__SmaccTransition__Sequence__destroy(smacc2_msgs__msg__SmaccTransition__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    smacc2_msgs__msg__SmaccTransition__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
smacc2_msgs__msg__SmaccTransition__Sequence__are_equal(const smacc2_msgs__msg__SmaccTransition__Sequence * lhs, const smacc2_msgs__msg__SmaccTransition__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!smacc2_msgs__msg__SmaccTransition__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
smacc2_msgs__msg__SmaccTransition__Sequence__copy(
  const smacc2_msgs__msg__SmaccTransition__Sequence * input,
  smacc2_msgs__msg__SmaccTransition__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(smacc2_msgs__msg__SmaccTransition);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    smacc2_msgs__msg__SmaccTransition * data =
      (smacc2_msgs__msg__SmaccTransition *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!smacc2_msgs__msg__SmaccTransition__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          smacc2_msgs__msg__SmaccTransition__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!smacc2_msgs__msg__SmaccTransition__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
